## antic 0.2.5+ds

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.1)

project(antic C)

file(READ "${CMAKE_CURRENT_SOURCE_DIR}/configure" CONFIGURE_CONTENTS)
string(REGEX MATCH "ANTIC_MAJOR=([0-9]*)" _ ${CONFIGURE_CONTENTS})
set(ANTIC_MAJOR ${CMAKE_MATCH_1})
string(REGEX MATCH "ANTIC_MINOR=([0-9]*)" _ ${CONFIGURE_CONTENTS})
set(ANTIC_MINOR ${CMAKE_MATCH_1})
string(REGEX MATCH "ANTIC_PATCH=([0-9]*)" _ ${CONFIGURE_CONTENTS})
set(ANTIC_PATCH ${CMAKE_MATCH_1})

set(ANTIC_VERSION "${ANTIC_MAJOR}.${ANTIC_MINOR}.${ANTIC_PATCH}")

if (NOT CMAKE_BUILD_TYPE)
    set(CMAKE_BUILD_TYPE Release CACHE STRING "Build type (Debug, Release)" FORCE)
endif ()

set (BUILD_SHARED_LIBS yes CACHE BOOL "Build shared library or not")
set (BUILD_TESTING no CACHE BOOL "Build tests or not")

if (NOT (CMAKE_BUILD_TYPE STREQUAL "Debug" OR
        CMAKE_BUILD_TYPE STREQUAL "Release"))
    message("${CMAKE_BUILD_TYPE}")
    message(FATAL_ERROR "CMAKE_BUILD_TYPE must be one of: Debug, Release (current value: '${CMAKE_BUILD_TYPE}')")
endif ()

if ("${CMAKE_SIZEOF_VOID_P}" STREQUAL "8")
    set (PLATFORM "x64")
else ()
    set (PLATFORM "Win32")
endif()

if (BUILD_SHARED_LIBS)
    set (LIBRARY_TYPE dll)
else ()
    set (LIBRARY_TYPE lib)
endif()

set (MSVC_USE_MT yes CACHE BOOL "Use MT flags when compiling in MSVC")
set (MSVC_WARNING_LEVEL 1 CACHE STRING "MSVC warning level")

if (MSVC)
    if (MSVC_USE_MT)
        foreach(CompilerFlag CMAKE_C_FLAGS_DEBUG CMAKE_C_FLAGS_RELEASE)
          string(REPLACE "/MD" "/MT" ${CompilerFlag} "${${CompilerFlag}}")
        endforeach()
    endif()
    foreach(CompilerFlag CMAKE_C_FLAGS)
      set(${CompilerFlag} "${${CompilerFlag}} /W${MSVC_WARNING_LEVEL}")
    endforeach()

    foreach(CompilerFlag CMAKE_C_FLAGS_DEBUG CMAKE_C_FLAGS_RELEASE)
        if (BUILD_SHARED_LIBS)
            set(${CompilerFlag} "${${CompilerFlag}} /DMSC_USE_DLL")
        else ()
            set(${CompilerFlag} "${${CompilerFlag}} /DPTW32_STATIC_LIB")
        endif()
    endforeach()

    if ("${LIBRARY_TYPE}" STREQUAL "dll")
        set(CMAKE_WINDOWS_EXPORT_ALL_SYMBOLS yes)
    endif()
endif()

set (DEPS flint2 mpfr mpir)

set (mpir_lib gmp mpir)
set (mpfr_lib mpfr)
set (flint2_lib ${LIBRARY_TYPE}_flint flint)

set (mpir_header gmp.h)
set (mpfr_header mpfr.h)
set (flint2_header flint/flint.h)

foreach (LIB ${DEPS})
    string (TOUPPER ${LIB} LIB_UPPER)
    find_library(${LIB_UPPER}_LIBRARY NAMES ${${LIB}_lib} HINTS ../${LIB}
                 PATH_SUFFIXES ${LIBRARY_TYPE}/${PLATFORM}/${CMAKE_BUILD_TYPE})
    if (NOT ${LIB_UPPER}_LIBRARY)
        message(FATAL_ERROR "${LIB} library not found.")
    endif()
    add_library(${LIB} UNKNOWN IMPORTED)
    set_property(TARGET ${LIB} PROPERTY IMPORTED_LOCATION ${${LIB_UPPER}_LIBRARY})
    message("${LIB} found in ${${LIB_UPPER}_LIBRARY}")
endforeach ()

foreach (LIB ${DEPS})
    string(TOUPPER ${LIB} HEADER_PKG)
    set (HEADER ${${LIB}_header})
    find_path(${HEADER_PKG}_INCLUDE_DIR NAMES ${HEADER} HINTS ../${LIB}
             PATH_SUFFIXES ${LIBRARY_TYPE}/${PLATFORM}/${CMAKE_BUILD_TYPE})
    if (NOT ${HEADER_PKG}_INCLUDE_DIR)
        message(FATAL_ERROR "${HEADER} header not found.")
    endif()
    message("${HEADER} found in ${${HEADER_PKG}_INCLUDE_DIR}")
    set (DEP_INCLUDE_DIRS ${DEP_INCLUDE_DIRS} ${${HEADER_PKG}_INCLUDE_DIR})
endforeach ()

file(GLOB TEMP "*.h")

foreach (TEMP_H ${TEMP})
    get_filename_component(FOLDER ${TEMP_H} NAME_WE)
    set(FOLDERS ${FOLDERS} ${FOLDER})
endforeach()

foreach (FOLDER ${FOLDERS})
    file(GLOB TEMP "${FOLDER}/*.c")
    set(SRC ${SRC} ${TEMP})
endforeach ()

include_directories(BEFORE ${antic_SOURCE_DIR})
include_directories(BEFORE ${DEP_INCLUDE_DIRS})

add_library(antic ${SRC})
target_link_libraries(antic ${DEPS})
target_compile_definitions(antic PRIVATE "ANTIC_BUILD_DLL")

set_target_properties(antic PROPERTIES VERSION ${ANTIC_VERSION} SOVERSION ${ANTIC_MAJOR})
if(WIN32)
    set_target_properties(antic PROPERTIES RUNTIME_OUTPUT_NAME "antic-${ANTIC_MAJOR}")
endif()

if(NOT MSVC)
    target_link_libraries(antic m)
endif()

install(TARGETS antic
            RUNTIME DESTINATION bin
            ARCHIVE DESTINATION lib
            LIBRARY DESTINATION lib
        )

foreach (FOLDER ${FOLDERS})
    set(HEADERS ${HEADERS} ${FOLDER}.h)
endforeach ()

install(FILES ${HEADERS} DESTINATION include/antic)

if (BUILD_TESTING)
    enable_testing()
    foreach (FOLDER ${FOLDERS})
        file(GLOB TEMP "${FOLDER}/test/*.c")
        foreach (TEST_SOURCE ${TEMP})
            get_filename_component(TEST_NAME ${TEST_SOURCE} NAME_WE)
            add_executable(${FOLDER}-${TEST_NAME} ${TEST_SOURCE})
            target_link_libraries(${FOLDER}-${TEST_NAME} antic)
            add_test(${FOLDER}-${TEST_NAME} ${FOLDER}-${TEST_NAME})
        endforeach ()
    endforeach ()
endif ()

## antic 0.2.4+ds

=== debian/changelog ===
antic (0.2.4+ds-2) unstable; urgency=medium

  * Source upload.
  * Debianization:
    - d/patches/*:
      - d/p/upstream-configure-version_script.patch, harden.

 -- Jerome Benoit <calculus@rezozer.net>  Sat, 19 Feb 2022 10:29:34 +0000

antic (0.2.4+ds-1) unstable; urgency=medium

  * Initial release. (Closes: #990638)

 -- Jerome Benoit <calculus@rezozer.net>  Sun, 13 Feb 2022 17:03:36 +0000

=== debian/control ===
Source: antic
Section: math
Priority: optional
Maintainer: Debian Math Team <team+math@tracker.debian.org>
Uploaders: Jerome Benoit <calculus@rezozer.net>
Rules-Requires-Root: no
Build-Depends:
 debhelper-compat (= 13),
 libflint-dev
Standards-Version: 4.6.0
Homepage: https://github.com/wbhart/antic/
Vcs-Git: https://salsa.debian.org/math-team/antic.git
Vcs-Browser: https://salsa.debian.org/math-team/antic

Package: libantic0
Provides: libantic
Section: libs
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Conflicts: libantic
Multi-Arch: same
Description: Algebraic Number Theory In C - libs
 ANTIC is an Algebraic Number Theory library In C.
 .
 This package provides the shared libraries required to run programs compiled
 against the ANTIC library. To compile your own programs you also need to
 install the libantic-dev package.

Package: libantic-dev
Section: libdevel
Architecture: any
Depends:
 libflint-dev,
 libantic0 (= ${binary:Version}),
 ${misc:Depends}
Conflicts: libantic-dev
Multi-Arch: same
Description: Algebraic Number Theory In C - libdev
 ANTIC is an Algebraic Number Theory library In C.
 .
 This package contains static libraries and symbolic links that developers
 using the ANTIC library will need.

=== debian/rules ===
#!/usr/bin/make -f
include /usr/share/dpkg/pkg-info.mk

export DEB_BUILD_MAINT_OPTIONS=hardening=+all

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

default:
	@uscan --no-conf --dehs --report || true

%:
	dh $@

override_dh_auto_configure:
	./configure \
		--prefix=/usr \
		--disable-cxx


override_dh_auto_install:
	dh_auto_install -- LIBDIR=lib/$(DEB_HOST_MULTIARCH)

=== debian/watch ===
version=4
opts=repack,repacksuffix=+ds,compression=xz,dversionmangle=s/\+ds// \
https://github.com/wbhart/antic/tags .*/v?(\d\S+)\.tar\.gz

## antic 0.2.5%2Bds

=== debian/changelog ===
antic (0.2.5+ds-1build1) kinetic; urgency=medium

  * No-change rebuild against libflint17

 -- Graham Inggs <ginggs@ubuntu.com>  Sat, 16 Jul 2022 09:36:11 +0000

antic (0.2.5+ds-1) unstable; urgency=medium

  * Team upload.
  * New upstream release.
  * Don't use setup.py to clean the package.
  * Bump standards-version to 4.6.1.

 -- Julien Puydt <jpuydt@debian.org>  Fri, 24 Jun 2022 22:22:03 +0200

## antic 0.2.5+ds

=== debian/control ===
--- 
+++ 
@@ -7,7 +7,7 @@
 Build-Depends:
  debhelper-compat (= 13),
  libflint-dev
-Standards-Version: 4.6.0
+Standards-Version: 4.6.1
 Homepage: https://github.com/wbhart/antic/
 Vcs-Git: https://salsa.debian.org/math-team/antic.git
 Vcs-Browser: https://salsa.debian.org/math-team/antic

=== debian/rules ===
--- 
+++ 
@@ -11,6 +11,9 @@
 %:
 	dh $@
 
+override_dh_auto_clean:
+	# don't try to use setup.py
+
 override_dh_auto_configure:
 	./configure \
 		--prefix=/usr \

=== debian/tests/control ===
Tests: make-check-dev
Depends: libantic-dev, build-essential
